// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

var enableSlidersUpdate,
    enableSensorsUpdate,
	enableLimitsupdate;
//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	enableSlidersUpdate = 1;
	enableSensorsUpdate = 1;
	enableLimitsupdate = 1;
	document.getElementById("error_message_txt").style.display = 'none';
	checkBootStatus();
	updateSensors();
}

function checkBootStatus()
{
	var plist = widget.system("/bin/cat /Library/LaunchDaemons/it.andreafabrizi.g4fancontrol.plist", null).outputString;
	if (!plist)
		document.getElementById("checkbox_remember_boot").checked = false;
	else document.getElementById("checkbox_remember_boot").checked = true;
}

function updateSensors()
{
	if (enableSensorsUpdate == 0)
	{
		setTimeout("updateSensors()", 1000);
		return;
	}
	
	//Get stats
	var ilstats = widget.system("/usr/sbin/g4fancontrol --ilstats | grep ILSTATS", null).outputString;
	
	//Check if g4fc is correctly installed
	if (!ilstats)
	{
		enableSlidersUpdate = 0;
		enableSensorsUpdate = 0;
		enableLimitsupdate = 0;
		document.getElementById("error_message_txt").style.display = '';
		showBack(null);
		return;
	}
	
	var stats_array=ilstats.split(" ");
	
	var stats_sens_temp_1 = parseInt(stats_array[1]),
		stats_sens_temp_2 = parseInt(stats_array[2]),
		stats_sens_temp_3 = parseInt(stats_array[3]),
		stats_sens_limit_1 = parseInt(stats_array[4]),
		stats_sens_limit_2 = parseInt(stats_array[5]),
		stats_sens_limit_3 = parseInt(stats_array[6].split("\n")[0]);
	
	if ((stats_sens_temp_1 == 255) || (stats_sens_temp_2 == 255) || (stats_sens_temp_3 == 255) ||
		(stats_sens_limit_1 == 255) || (stats_sens_limit_2 == 255) || (stats_sens_limit_3 == 255))
	{
		setTimeout("updateSensors()", 1000);
		return;
	}
	
	//Update labels
	document.getElementById("sens_temp_1").innerText = stats_sens_temp_1 + "°C";
	document.getElementById("sens_temp_2").innerText = stats_sens_temp_2 + "°C";
	document.getElementById("sens_temp_3").innerText = stats_sens_temp_3 + "°C";
	
	if (enableSlidersUpdate == 1)
	{
		document.getElementById("sens_limit_1").innerText = stats_sens_limit_1 + "°C";
		document.getElementById("sens_limit_2").innerText = stats_sens_limit_2 + "°C";
		document.getElementById("sens_limit_3").innerText = stats_sens_limit_3 + "°C";
	}
	
	//Update gauges
	document.getElementById("gauge_sens_1").object.setValue(stats_sens_temp_1);
	document.getElementById("gauge_sens_2").object.setValue(stats_sens_temp_2);
	document.getElementById("gauge_sens_3").object.setValue(stats_sens_temp_3);

	//Update sliders
	if (enableSlidersUpdate == 1)
		updateSliders(stats_sens_limit_1, stats_sens_limit_2, stats_sens_limit_3);

	setTimeout("updateSensors()", 3000);
}

function updateSliders(sens1, sens2, sens3)
{	
	document.getElementById("slider_limit_1").value = sens1;
	document.getElementById("slider_limit_2").value = sens2;
	document.getElementById("slider_limit_3").value = sens3;
}

function startDragSlider()
{
	enableSlidersUpdate = 0;
}

function stopDragSlider()
{
	setSensorLimits();
	enableSlidersUpdate = 1;
}

function draggingSliders()
{
	if (enableLimitsupdate == 0) return;
	
	var stats_sens_limit_1 = document.getElementById("slider_limit_1").value,
		stats_sens_limit_2 = document.getElementById("slider_limit_2").value,
		stats_sens_limit_3 = document.getElementById("slider_limit_3").value;

	document.getElementById("sens_limit_1").innerText = stats_sens_limit_1 + "°C";
	document.getElementById("sens_limit_2").innerText = stats_sens_limit_2 + "°C";
	document.getElementById("sens_limit_3").innerText = stats_sens_limit_3 + "°C";
}

function setSensorLimits()
{
	enableSensorsUpdate = 0;
	
	var sens1 = document.getElementById("slider_limit_1").value,
		sens2 = document.getElementById("slider_limit_2").value,
		sens3 = document.getElementById("slider_limit_3").value;
		
	widget.system("/usr/sbin/g4fancontrol --set-sensor-0 " + sens1 + " --set-sensor-1 " + sens2 + " --set-sensor-2 " + sens3, null);

	enableSensorsUpdate = 1;
}

function goToDeveloperSite()
{
	widget.openURL("http://www.andreafabrizi.it/?g4fancontrol:download");
}

function rememberBoot()
{

	var sens1 = document.getElementById("slider_limit_1").value,
		sens2 = document.getElementById("slider_limit_2").value,
		sens3 = document.getElementById("slider_limit_3").value;
		
	if (document.getElementById("checkbox_remember_boot").checked == true)
		widget.system("/usr/sbin/g4fancontrol --set-boot " + sens1 + ":" + sens2 + ":" + sens3, null);
	else widget.system("/usr/sbin/g4fancontrol --unset-boot", null);
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}
